/*!
 * jQuery $.wijit
 * Original author: @t1mmen
 * Licensed under the MIT license
 * 
 * @url : https://github.com/t1mmen/jquery.wijit/
 * @date : Nov 29th, 15:43 2011
 */

;(function ( $, window, document, undefined ) {

	/************************************************
	 * Helper functions.
	 ***********************************************/	
	var functions = {
				 
		/************************************************
		 * Handles the submit button
		 ***********************************************/
		addWijit : function(form) {

									
		},
		
		/**
		 * Expand "move to" areas surrounding .wijit's
		 */
		toggleMove : function() {





		},

		/**
		 * Loop through .wijit-containers's data-wijit-support
		 * and disable all unsupported wijit types
		 */
		updateMenu : function() {

		},

		// Show the toolbar above a wijit
		showToolbar : function(wijit) {
			

			var wijitType = wijit.data('wijit').type,
				WijitId = wijit.data('wijit').id,
				// find the appropriate controller for this widget type
				wijitToolbar = $('#wijit-' + wijitType + '-toolbar'),
				wijitPosition = wijit.offset(),
				wijitHeight = wijit.height(),
				wijitWidth = wijit.innerWidth()-22,
				wijitButtons = wijitToolbar.children('.btn-group');

			// Cancel toolbar hiding (if set)
			$.doTimeout('timeout-for-' + wijitToolbar);
			
			// Link controller to the wijit we're active on.
			$(this).data('wijit-controlling-id', wijit.attr('id'));
									
			// Close the toolbar		
			if (wijitButtons.hasClass('open')) {		
				wijitButtons.doTimeout(100, function(){
					wijitButtons.removeClass('open');
				});
			}							

			wijitToolbar.css('left', wijitPosition.left);
			wijitToolbar.css('top', wijitPosition.top-35);
			wijitToolbar.addClass('in');

			// Secondary wijit controller
			if (wijitType == 'image') {
				$('#wijit-image-second-toolbar')
					.css('width', wijitWidth)
					.css('left', wijitPosition.left)
					.css('top', wijitPosition.top+wijitHeight)
					.addClass('in');
			}
		
			//wijit.addClass("hover");

		},

		// Hide the toolbar
		hideToolbar : function(wijit) {


			// Remove hover from the widget
			wijit.removeClass("hover");

			var wijitType = wijit.data('wijit').type,
				WijitId = wijit.data('wijit').id,
				// find the appropriate controller for this widget type
				wijitToolbar = $('#wijit-' + wijitType + '-toolbar'),
				wijitPosition = wijit.offset(),
				wijitButtons = wijitToolbar.children('.btn-group');


			
			// do a timeout. 
			// wijitType represents the id of the timeout event.
			wijitToolbar.doTimeout( 'timeout-for-' + wijitToolbar, 2000, function(elem){
				
				console.log($(this).data('mouseover'));
				// If the dropdown is expanded
				if ($(this).children('.btn-group').hasClass('open')) {
					
				} else if ($(this).data('mouseover') == 'no') {
					console.log('no');
				} else {

					// Hide toolbar
					wijit.removeClass('in');
				}
			}, this);

					


		},
		/************************************************
		 * Match the wijits with a toolbar on mouseover.
		 ***********************************************/
		attachToolbars : function (selector) {

			// Hoved the widget
		    $("div.wijit").mouseenter(function(e){

		    	e.stopPropagation();
		    	console.log($(this));

		    	return functions.showToolbar($(this));
						    	

		    }).mouseleave(function(e){
		  
		  		return functions.hideToolbar($(this));

							  
		    });

			// Set active wijit to keep focus on it.
		    $("div.wijit-controller").mouseenter(function(e){

		    	$(this).data('mouseover', 'yes');
						    	

		    }).mouseleave(function(e){
		  
		    	$(this).data('mouseover', 'no');
		  		//return functions.hideToolbar($(this));

							  
		    });		    
		
		}
		
	};
  

    // 
	/************************************************
	 * Plugin defaults.
	 ***********************************************/	    
    var pluginName = 'wijit',
        defaults = {
            
            // When should the form submit? onBlur, etc
            addTrigger 		: 'submit', 
            
            wijitSelector	: '.wijit',

            wijitSelector	: '.wijit',
            
            
            
            
            
            
        };


    // The actual plugin constructor
    function Plugin( form, options ) {
        this.element = form;

        // merge defaults and options.
        this.options = $.extend( {}, defaults, options) ;

        this._defaults = defaults;
        this._name = pluginName;

        this.init();
        
        
        

        
    }

    Plugin.prototype.init = function () {
        // Place initialization logic here
        // You already have access to the DOM element and
        // the options via the instance, e.g. this.element
        // and this.options
        
        
        wijitOptions = this.options;
        
        // @todo toggle edit mode on body.
        if ($('body').data('edit-mode') != 'true') {

			// Hoved the widget
		    $(".columns").mouseenter(function(e){

		    	$(this).children('.wijit-creator').toggleClass('in')
						    	

		    }).mouseleave(function(e){
		  
		    	$(this).children('.wijit-creator').toggleClass('in')

							  
		    });	
		            	
        	/*
			$('[data-wijit-initializer]').on('click', function() {
				//var this = $(this);
				console.log('yeah');
				$('.wijit-creator').toggleClass('in');


			});*/
		}
        
        // Start catching addWijit actions
        //$('.wijit').on()

        $('.wijit-creator').on('click', function() {
        	
        	var wijitInitiator = $(this),
        		activeText = wijitInitiator.data('active-text');

        	wijitInitiator.toggleClass('active');
        	wijitInitiator.children('.btn-group').toggleClass('open');
        	wijitInitiator.find('.btn-group .btn').toggleClass('active');
        	//wijitInitiator.find('.btn-group .btn span').toggleClass('in');
        	
        	
        	//wijitInitiator.find('.btn').val(activeText);
        	$('.modal-backdrop').removeClass('hide').addClass('in');

        });


        $('[data-move="wijit"]').on('click', function() {

        	return functions.toggleMove($(this));
    	});

        // Bind 
        return functions.attachToolbars(this.options.wijitSelector);		
        
        
    };

    // A really lightweight plugin wrapper around the constructor,
    // preventing against multiple instantiations
    $.fn[pluginName] = function ( options ) {
        return this.each(function () {
            if (!$.data(this, 'plugin_' + pluginName)) {
                $.data(this, 'plugin_' + pluginName,
                new Plugin( this, options ));
            }
        });
        
    }

})( jQuery, window, document );